<?php

// Main settings file
// This file has the site-wide configuration

// *Always* work in a session
session_start();

define('WEB_ROOT', 			"https://secure.tbwb.nl/service/");
define('FS_ROOT', 			"/var/www/secure.tbwb.nl/public/service/");

// include libraries
include (FS_ROOT . "lib/generic.lib.php");
include (FS_ROOT . "lib/locale.lib.php");
include (FS_ROOT . "lib/burp.lib.php");
include (FS_ROOT . "lib/db.lib.php");
include (FS_ROOT . "config/db.inc.php");
include (FS_ROOT . "config/regex.inc.php");


// Setup directories
define('TPL_DIR', 			FS_ROOT . "tpl/");
define('TPL_COMPILE_DIR', 	FS_ROOT . "tpl_c/");
define('CACHE_DIR', 		FS_ROOT . "cache/");
define('CONFIG_DIR', 		FS_ROOT . "config/");
define('LANG_DIR',			FS_ROOT . "lang/");

// locale settings
// when the locale is set in the GET, use that and set the $_SESSION accordingly.
$lc_default = "nl_NL";
lc_start(LANG_DIR, "lc");

// burp config
$burp_config['index'] 					= "index.php";
$burp_config['logout_auto_relocate'] 	= false;
$burp_config['mail_from']				= "TBWB Service Website <service@tbwb.nl>";


$smarty = new Smarty;
$smarty->template_dir 	= TPL_DIR;
$smarty->compile_dir  	= TPL_COMPILE_DIR;
$smarty->cache_dir 		= CACHE_DIR;

// assign all known strings into the template
foreach ($lc_strings as $key=>$s) {
	$smarty->assign($key, _s($key));
}

// and a lot of other handy stuff
$smarty->assign("webroot", WEB_ROOT);


?>