
dojo.require("dojo.html");
dojo.require("dijit.Tooltip");

var user_ok = false;
var pass_ok = false;
var pass2_ok = false;
var mail_ok = false;

function init(){

	// disable the submit button, we will enable it again when all is OK
	dojo.byId("btnSubmit").disabled = true;
	
	// create tooltips
	//'reg_username', ru_tooltip
	
	new dijit.Tooltip(
		{
			connectId: ["qm_username"],
			label: _s("<b>Type your preferred username.</b><br>"+
				"It may only contain letters, numbers, underscores and dots.")
		});

	new dijit.Tooltip(
		{
			connectId: ["qm_password"],
			label: _s("<b>Type your preferred password.</b><br>"+
				"It has to be at least 6 characters long and strong anough to be accepted; the bar<br>"+
				"has to become green.<br>"+
				"Make sure to include letters, numbers and special characters.")
		});
		
	new dijit.Tooltip(
		{
			connectId: ["qm_password2"],
			label: _s("<b>Type your preferred password again.</b><br>"+
				"We require the second password to prevent typing errors.")
		});		
		
	new dijit.Tooltip(
		{
			connectId: ["qm_email"],
			label: _s("<b>Type your email address.</b><br>"+
				"It has to be a valid address.")
		});	
		
		
	if (dojo.byId("reg_username").value != "") {
		// failed register, check all
		check_username();
		check_email();
	}
	dojo.byId("reg_username").focus();
}

function check_username() {
	dojo.style("ok_username", "display", "none");
	user_ok = false;
	user_name = dojo.byId("reg_username").value;
	
	// check if username is valid
	if (user_name.match(transfer['regex']['username'])) {
		// valid, check existance
		dojo.html.set(dojo.byId("reg_user_msg"), _s("Checking username..."));
		
		dojo.xhrPost({
			url: 'json.php',
			load: check_username_cb,
			content: {
				action: "burp_user_exists",
				arguments: dojo.toJson(dojo.byId("reg_username").value)
			}
		});
	} else {
		username_mark(_s("Invalid username."));
	}
}

function check_username_cb(data, ioArgs) {
	var oResult = dojo.fromJson(data);
	
	if (oResult == true) {
		username_mark(_s("User already exists."))
	} else {
		username_mark(_s(""));
	}
}

function username_mark(s) {
	if (s == "") {
		// no message, username is ok
		dojo.html.set(dojo.byId("reg_user_msg"), _s(""));
		user_ok = true;
		dojo.style("ok_username", "display", "inline");
	} else {
		// message is set, show message
		dojo.html.set(dojo.byId("reg_user_msg"), s);
	}
	
	check_all();
}


function check_email() {
	var iResult = test_email(dojo.byId("reg_email").value);
	dojo.style("ok_email", "display", "none");
	
	if (iResult) {
		dojo.html.set(dojo.byId("reg_email_msg"), _s(""));
		mail_ok = true;
		dojo.style("ok_email", "display", "inline");
	} else {
		dojo.html.set(dojo.byId("reg_email_msg"), _s("Invalid e-mail address."));
		mail_ok = false;
	}	
	
	check_all();
}

function check_password2() {
	var pw1 = dojo.byId("reg_password").value;
	var pw2 = dojo.byId("reg_password2").value;

	dojo.html.set(dojo.byId("reg_pass2_msg"), _s("Passwords do not match"));
	dojo.style("ok_password2", "display", "none");
	pass2_ok = false;
	
	if (pw1 == pw2) {
		dojo.style("ok_password2", "display", "inline");
		dojo.html.set(dojo.byId("reg_pass2_msg"), _s(""));
		pass2_ok = true;
	}
	
	check_all();
}

function check_password() {
	var iResult = test_password(dojo.byId("reg_password").value);
	var strColor = "green", strMessage = "Very strong.";
	var iColorWidth = 120, iSilverWidth = 0;
	
	pass_ok = false;
	dojo.style("ok_password", "display", "none");
	
	if (iResult <= 6) {
		strColor = "red";
		strMessage = "Weak.";
		iColorWidth = 30;
	} else if (iResult <= 10) {
		strColor = "yellow";
		strMessage = "Mediocre.";
		iColorWidth = 60; 
	} else {
		if (iResult <= 17) {
			iColorWidth = 90;
			strMessage = "Strong.";
		}
		strColor = "green";		
		pass_ok = true;
		dojo.style("ok_password", "display", "inline");
	} 
	
	iSilverWidth = 120 - iColorWidth;
	
	dojo.byId("pw_gauge_color").src = "img/"+strColor + "1px.png";
	dojo.byId("pw_gauge_silver").src = "img/silver1px.png";
	
	dojo.style("pw_gauge_color", "width", ""+iColorWidth+"px");
	dojo.style("pw_gauge_silver", "width", ""+iSilverWidth+"px");
	dojo.style("pw_gauge_color", "display", "inline");
	dojo.style("pw_gauge_silver", "display", "inline");
	
	dojo.html.set(dojo.byId("reg_pass_msg"), _s(strMessage));
	
	check_all();
}

function check_all() {
	if (pass_ok && mail_ok && user_ok && pass2_ok) {
		dojo.byId("btnSubmit").disabled = false;
	} else {
		dojo.byId("btnSubmit").disabled = true;
	}
}
