<?php

// locale.php
//
// Implements functions for multi-language support.
// All functions defined here start with lc_

$lc_ok = false;
$lc_strings = array();
$lc_file = "";
$lc = "";

function lc_current() {
	global $lc;
	return $lc;
}

function lc_start($lang_dir, $lang_ext) {
	global $lc_strings, $lc_ok, $lc_default, $lc_file, $lc;
		
	// find out the locale to use
	if (isset($_REQUEST['lc'])) {
		// we received a locale in the request, use that 
		$lc = $_REQUEST['lc'];
		
		if (is_array($_SESSION)) {
			// ... and register in the session if that is available			
			$_SESSION['lc'] = $lc;
		}
	} else {
		// otherwise, use the previously set session var
		if (isset($_SESSION['lc'])) {
			$lc = $_SESSION['lc'];
		} else {
			// fallback to the default
			$lc = $lc_default;
		}
	}
	
	$lc_file = $lang_dir ."$lc." . $lang_ext;
	
	if (file_exists($lc_file)) {
		include ($lc_file);
		$lc_ok = true;
	} else {
		user_error("Couldn't find LC file: ".$lc_file);
	}
}

// Translate $string
function _s($string) {
	global $lc_ok, $lc_strings, $lc_file;
	$ret = $string;

	if ($lc_ok === true && is_array($lc_strings) && @$lc_strings[$string] !== "<undefined>") {
		if (isset ($lc_strings[$string])) {
			$ret = $lc_strings[$string];
		} else {
			// string was not found, add to file			
			$file = file($lc_file);
			array_pop($file);
			array_push($file, "\$lc_strings[\"$string\"]		= \"<undefined>\";\n?>");
			
			$fp = fopen($lc_file, "w");
			for ($ctr = 0; $ctr < count($file); $ctr++) {
				fwrite ($fp, $file[$ctr]);				
			}
			fclose($fp);
		}
	}
	
	return $ret;
}

?>
